VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Groups Pages
Classes | Public Types | Public Member Functions | Static Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
CControl Class Referenceabstract

base class of all VSTGUI controls More...

Inheritance diagram for CControl:

## Classes
struct | Impl

## Public Types
using | CheckDefaultValueEventFuncT = bool(*)(CControl *, MouseDownEvent &)
using | CheckDefaultValueFuncT = bool(*)(CControl *, CButtonState)
Public Types inherited from CView
enum | MouseListenerCall { MouseDown, MouseMoved, MouseUp, MouseCancel }

## Public Member Functions
| CControl (const CRect &size, IControlListener *listener=nullptr, int32_t tag=0, CBitmap *pBackground=nullptr)
| CControl (const CControl &c)
void | draw (CDrawContext *pContext) override=0
| called if the view should draw itself
bool | isDirty () const override
| check if view is dirty
void | setDirty (bool val=true) override
| set the view to dirty so that it is redrawn in the next idle.
bool | drawFocusOnTop () override
| draw focus before view will be drawn or afterwards
bool | getFocusPath (CGraphicsPath &outPath) override
| the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor()
CBaseObject * | newCopy () const override=0
Value Methods
virtual void | setValue (float val)
virtual float | getValue () const
virtual void | setValueNormalized (float val)
virtual float | getValueNormalized () const
virtual void | setMin (float val)
virtual float | getMin () const
virtual void | setMax (float val)
virtual float | getMax () const
float | getRange () const
virtual void | setOldValue (float val)
virtual float | getOldValue () const
virtual void | setDefaultValue (float val)
virtual float | getDefaultValue () const
virtual void | bounceValue ()
virtual void | valueChanged ()
| notifies listener and dependent objects
Editing Methods
virtual void | setTag (int32_t val)
virtual int32_t | getTag () const
virtual void | beginEdit ()
virtual void | endEdit ()
bool | isEditing () const
virtual IControlListener * | getListener () const
| get main listener
virtual void | setListener (IControlListener *l)
| set main listener
void | registerControlListener (IControlListener *listener)
| register a sub listener
void | unregisterControlListener (IControlListener *listener)
| unregister a sub listener
Misc
virtual void | setWheelInc (float val)
virtual float | getWheelInc () const
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
void | setSubviewState (bool state)
bool | isSubview () const
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes
void | setTooltipText (UTF8StringPtr text)
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
virtual void | dispatchEvent (Event &event)
| dispatch an event
virtual void | onMouseDownEvent (MouseDownEvent &event)
| called when a mouse down event occurs
virtual void | onMouseMoveEvent (MouseMoveEvent &event)
| called when a mouse move event occurs
virtual void | onMouseUpEvent (MouseUpEvent &event)
| called when a mouse up event occurs
virtual void | onMouseCancelEvent (MouseCancelEvent &event)
| called when mouse tracking should be canceled
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view
virtual void | onMouseWheelEvent (MouseWheelEvent &event)
| called when a mouse wheel event occurs
virtual void | onZoomGestureEvent (ZoomGestureEvent &event)
| called when a zoom gesture event occurs
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer.
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
virtual bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons)
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| A drag can only be started from within onMouseDown or onMouseMove.
virtual SharedPointer < IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown
virtual void | onKeyboardEvent (KeyboardEvent &event)
| called when a keyboard event is dispatched to this view
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
CCoord | getHeight () const
| get the height of the view
CCoord | getWidth () const
| get the width of the view
virtual void | setViewSize (const CRect &rect, bool invalid=true)
| set views size
const CRect & | getViewSize () const
| read only access to view size
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags
int32_t | getAutosizeFlags () const
| get autosize flags
virtual bool | sizeToFit ()
| resize view to optimal size
virtual void | looseFocus ()
| called if view should loose focus
virtual void | takeFocus ()
| called if view should take focus
virtual bool | wantsFocus () const
| check if view supports focus
virtual void | setWantsFocus (bool state)
| set focus support on/off
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute
virtual void | setBackground (CBitmap *background)
| set the background image of this view
CBitmap * | getBackground () const
| get the background image of this view
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state.
virtual void | setTransparency (bool val)
| set views transparent state
bool | getTransparency () const
| get views transparent state
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view
float | getAlphaValue () const
| get alpha value
virtual bool | removed (CView *parent)
| view is removed from parent view
virtual bool | attached (CView *parent)
| view is attached to a parent view
bool | isAttached () const
| is view attached to a parentView
CView * | getParentView () const
| get parent view
CFrame * | getFrame () const
| get frame
virtual VSTGUIEditorInterface * | getEditor () const
| get editor
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view
template<typename T >
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms
template<typename T >
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
| called if the view should draw itself
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid
virtual void | invalid ()
| mark whole view as invalid
virtual void | setVisible (bool state)
| set visibility state
bool | isVisible () const
| get visibility state
virtual void | onIdle ()
| called on idle when view wants idle
void | setWantsIdle (bool state)
| enable/disable onIdle() callback
bool | wantsIdle () const
| returns if the view wants idle callback or not
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexceptoverride=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
virtual CMessageResult | notify ([[maybe_unused]] CBaseObject *sender,[[maybe_unused]] IdStringPtr message)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
Public Member Functions inherited from IFocusDrawing
virtual | ~IFocusDrawing () noexcept=default

## Static Public Attributes
static CheckDefaultValueEventFuncT | CheckDefaultValueEventFunc
| Function to check if a mouse down event should reset the value to its default value for a *control.
static int32_t | kZoomModifier = kShift
| zoom modifier key, per default is the shift key
static int32_t | kDefaultValueModifier = kControl
static CheckDefaultValueFuncT | CheckDefaultValueFunc
Static Public Attributes inherited from CView
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle.
static uint32_t | idleRate = 30
| global idle rate in Hz, defaults to 30 Hz

## Protected Member Functions
| ~CControl () noexceptoverride
Protected Member Functions inherited from CView
| ~CView () noexceptoverride
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## Static Protected Member Functions
static int32_t | mapVstKeyModifier (int32_t vstModifier)

## Protected Attributes
IControlListener * | listener
int32_t | tag
float | value

## Additional Inherited Members
Protected Types inherited from CView
enum | { kMouseEnabled = 1 << 0, kTransparencyEnabled = 1 << 1, kWantsFocus = 1 << 2, kIsAttached = 1 << 3, kVisible = 1 << 4, kDirty = 1 << 5, kWantsIdle = 1 << 6, kIsSubview = 1 << 7, kHasAlpha = 1 << 8, kHasBackground = 1 << 9, kHasDisabledBackground = 1 << 10, kHasMouseableArea = 1 << 11, kLastCViewFlag = 11 }

## Detailed Description

base class of all VSTGUI controls

This object manages the tag identification and the value of a control object.

## Member Typedef Documentation

using CheckDefaultValueEventFuncT = bool (*) (CControl*, MouseDownEvent&)

using CheckDefaultValueFuncT = bool (*) (CControl*, CButtonState)

## Constructor & Destructor Documentation

CControl | ( | const CRect & | size,
|  | IControlListener * | listener = `nullptr`,
|  | int32_t | tag = `0`,
|  | CBitmap * | pBackground = `nullptr`
| ) |  |

CControl | ( | const CControl & | c | ) |

~CControl | ( |  | ) |
| override protected noexcept

## Member Function Documentation

void beginEdit | ( |  | ) |
| virtual

void bounceValue | ( |  | ) |
| virtual

void draw | ( | CDrawContext * | pContext | ) |
| override pure virtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Reimplemented from CView.

Implemented in COptionMenu, CTextButton, CAnimKnob, CSlider, CRockerSwitch, CKickButton, CSegmentButton, CKnob, CParamDisplay, CCheckBox, CAnimationSplashScreen, CTextEdit, CTextLabel, CVuMeter, CScrollbar, CListControl, COnOffButton, CMovieBitmap, CMovieButton, CAutoAnimation, CSwitchBase, CSearchTextEdit, CSplashScreen, CXYPad, CSpecialDigit, and CControlCreatorDummyControl.

bool drawFocusOnTop | ( |  | ) |
| override virtual

draw focus before view will be drawn or afterwards

Implements IFocusDrawing.

Reimplemented in CSegmentButton, CKnob, and CListControl.

void endEdit | ( |  | ) |
| virtual

float getDefaultValue | ( | void |  | ) | const
| virtual

bool getFocusPath | ( | CGraphicsPath & | outPath | ) |
| override virtual

the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor()

Implements IFocusDrawing.

Reimplemented in CSegmentButton, CKnob, CParamDisplay, and CListControl.

virtual IControlListener* getListener | ( |  | ) | const
| inline virtual

get main listener

float getMax | ( |  | ) | const
| virtual

Reimplemented in COptionMenu.

float getMin | ( |  | ) | const
| virtual

Reimplemented in COptionMenu.

float getOldValue | ( | void |  | ) | const
| virtual

float getRange | ( |  | ) | const
| inline

virtual int32_t getTag | ( |  | ) | const
| inline virtual

virtual float getValue | ( |  | ) | const
| inline virtual

float getValueNormalized | ( |  | ) | const
| virtual

float getWheelInc | ( |  | ) | const
| virtual

bool isDirty | ( |  | ) | const
| override virtual

check if view is dirty

Reimplemented from CView.

bool isEditing | ( |  | ) | const

int32_t mapVstKeyModifier | ( | int32_t | vstModifier | ) |
| static protected

CBaseObject* newCopy | ( |  | ) | const
| override pure virtual

Implemented in COptionMenu, CTextButton, CAnimKnob, CRockerSwitch, CKickButton, CSlider, CSegmentButton, CKnob, CParamDisplay, CHorizontalSwitch, CCheckBox, CTextEdit, CVerticalSwitch, CExternalControl, CAutoAnimation, CScrollbar, CListControl, CTextLabel, CVuMeter, CKnobBase, CMovieButton, COnOffButton, CMovieBitmap, CSplashScreen, CSpecialDigit, and CControlCreatorDummyControl.

void registerControlListener | ( | IControlListener * | listener | ) |

register a sub listener

void setDefaultValue | ( | float | val | ) |
| virtual

Reimplemented in CXYPad.

void setDirty | ( | bool | val = `true` | ) |
| override virtual

set the view to dirty so that it is redrawn in the next idle.

Thread Safe !

Reimplemented from CView.

Reimplemented in CVuMeter.

virtual void setListener | ( | IControlListener * | l | ) |
| inline virtual

set main listener

void setMax | ( | float | val | ) |
| virtual

Reimplemented in COptionMenu, CXYPad, CListControl, and CKnobBase.

void setMin | ( | float | val | ) |
| virtual

Reimplemented in COptionMenu, CXYPad, CListControl, and CKnobBase.

void setOldValue | ( | float | val | ) |
| virtual

void setTag | ( | int32_t | val | ) |
| virtual

void setValue | ( | float | val | ) |
| virtual

Reimplemented in COptionMenu, CMultiLineTextLabel, CTextEdit, and CExternalControl.

void setValueNormalized | ( | float | val | ) |
| virtual

void setWheelInc | ( | float | val | ) |
| virtual

void unregisterControlListener | ( | IControlListener * | listener | ) |

unregister a sub listener

void valueChanged | ( |  | ) |
| virtual

notifies listener and dependent objects

Reimplemented in CSegmentButton, CTextEdit, and CTextLabel.

## Member Data Documentation

CControl::CheckDefaultValueEventFuncT CheckDefaultValueEventFunc
| static

Initial value:
=
[] (CControl* c, MouseDownEvent& event) {
if (event.buttonState.isLeft ())
{
return CheckDefaultValueFunc (c, buttonStateFromMouseEvent (event));
}
return false;
}

Function to check if a mouse down event should reset the value to its default value for a *control.

Per default this checks for a left mouse down button and the control modifier key.

CControl::CheckDefaultValueFuncT CheckDefaultValueFunc
| static

Initial value:
= [] (CControl*,
CButtonState button) {
return (button.isLeftButton () && button.getModifierState () == kDefaultValueModifier);
}

Deprecated:
  Function to check if the button state is the state to set the control value to its default value.

The default implementation uses the kDefaultValueModifier (see above). Use this to change this to double click per example. But consider to change this to the same behaviour as the host you are running in for best user experience.

int32_t kDefaultValueModifier = kControl
| inline static

Deprecated:
  default value modifier key, per default is the control key

int32_t kZoomModifier = kShift
| inline static

zoom modifier key, per default is the shift key

IControlListener* listener
| protected

int32_t tag
| protected

float value
| protected

The documentation for this class was generated from the following files:

- ccontrol.h
- ccontrol.cpp